import scrapy

## scrapy crawl noticias -t json --nolog -o noticias.json -a year=2017 -a month=3 -a day=22

import re
from scrapy_splash import SplashRequest

"""
Para este sitio se hace uso de scrapy-splash porque el contenido es cargago a traves de javascript
"""

TAG_RE = re.compile(r'<[^>]+>')
def remove_tags(text):
	return TAG_RE.sub('', text)


class NoticiasItem(scrapy.Item):
	title = scrapy.Field()
	text = scrapy.Field()
	date = scrapy.Field()
	location = scrapy.Field()
	author = scrapy.Field()
	topic = scrapy.Field()
	url = scrapy.Field()


class QuotesSpider(scrapy.Spider):
	name = "noticias"
	
	def start_requests(self):
		year = getattr(self, 'year', None)
		# month = getattr(self, 'month', None)
		# day = getattr(self, 'day', None)
		self.baseURL='http://hemeroteca.proceso.com.mx/?page_id=111058&edicion=mexico&page='
		this_year = 2017
		
		while this_year >= int(year):
			yield scrapy.Request(url=self.baseURL+str(year), callback=self.parse)
			this_year -= 1


	def parse(self, response):
		for link in response.xpath('//*[@class="catpor-post-thumb"]/a/@href').extract():
			yield scrapy.Request(url=link, callback=self.parse_2)


	def parse_2(self, response):
		for link in response.xpath('//*[@class="post-container clearfix"]/h2/a/@href').extract():
			# yield scrapy.Request(url=link, callback=self.parse_item)
			yield SplashRequest(url=link, callback=self.parse_item, endpoint='render.html', args={ 'wait': 0.5 })


	def parse_item(self, response):
		item = NoticiasItem()
		text = ''
		item['date'] = response.xpath('//div[@id="primary"]/div/div/div/div/span[@class="published"]/text()').extract_first()
		item['title'] = response.xpath('//div[@id="primary"]/div/h1/text()').extract_first()
		item['topic'] = response.xpath('//span[@class="entry-categories"]/text()').extract_first()
		for paragraph in response.xpath('//div[@id="primary"]/div/div/div/div[@class="entry-content"]/div/p').extract():
			text += remove_tags(paragraph) + '\n'
		item['text'] = text
		item['url'] = response.url
		# print item['title']
		yield item

